
;*****************************************************************************
;*                            DIMMER MIT POTI                                *
;*                                                                           *
;*                            19.02.24                                       *
;*                                                                           *
;*****************************************************************************

        LIST    P=12F675       
        TITLE   "DIMMER"

        ERRORLEVEL -302
        INCLUDE <P12F675.INC>

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------
                                                                                      
; ALS PIC-IC WURDE GENOMMEN PIC12F675
    
; ALS OSZILLATOR WURDE DER INTERNE OSZILLATOR MIT 4,0MHZ GENOMMEN.  (T=0.250SEC ALSO DIE TAKTZEIT) (T=1:FREQUENZ) 
; EIN BEFEHL HAT MEIST 4 TAKTE SIND 1,0SEC       
;
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;HIER KANN MAN AENDERN:
;EIN SEMIKOLON DAVOR BEWIRKT DAS DER "BEFEHL" ALS KOMMENTAR GILT. 
;
FREQUENZ                EQU  D'23'   ;BEISPIEL:  FREQUENZ FUER 50HZ //  1 : 50HZ = 20MSEC // 20MSEC : 255 (IMMER 255) = 78,4SEC : 3SEC (IMMER 3SEC) = 26 VORN EINTRAGEN
;                                               ;KORREKTUR --> ETWAS WENIGER EINTRAGEN JETZT NICHT 26 SONDERN 23 // GRUND : DIE ZS3MUESEC STIMMT NICHT EXAKT
		                                ;MIT OSZI FREQUENZ GEMESSSEN
                                                ;MAN SOLLTE ES SO LASSEN // ODER DIE D'23' KLEINER MACHEN BIS CA. D'10' // BEI D'10' SIND ES 102 HZ
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 21 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

HELP0                   EQU 0X21
AD_H                    EQU 0X22
AD_L                    EQU 0X23

;------------------------- MACROS -----------------------------------------
BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE              ; SOFORT INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        MOVLW   B'00110100'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP0 + GP1 DIGITAL I/O     AN2 (GP2) -ANALOG/DIGITAL WANDLER MIT RC-TAKT-INTERN  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                        MOVLW   B'11111100'                 ;GP0 + GP1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS (0X03FF) BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL

;INIT TIMER 0 FUER ZEITSCHLEIFE
;                        MOVLW   B'10000111'                 ;BIT0-2 111=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
;                        MOVWF   OPTION_REG      
                        BANK0
;INIT TIMER 1 FUER ZEITSCHLEIFE 
;                        MOVLW   B'00100000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [10]1:4 VORERST 0
;                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG
                        MOVLW   B'10001000' ;ADMF=1 RECHTSBNDIG, VDD ALS REF, CHANNEL AN2, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;---------------INITIALISIERUNG--ZU--ENDE-----------------------

ANFANG                  CALL    AN_MESSEN           ;AM POTI WIRD DIE SPANNUNG GEMESSEN

                        BSF     GPIO, BIT0          ;LEDS AUS+EINSCHALTEN
                        BCF     GPIO, BIT1

WEITER1                 MOVLW   FREQUENZ            ;BEISPIEL: 26*3SEC=78SEC SIEHE OBEN
                        CALL    ZS3MUESEC
                        DECFSZ  AD_H, F
                        GOTO    WEITER1

                        BCF     GPIO, BIT0          ;LEDS EIN+AUSSCHALTEN
                        BSF     GPIO, BIT1  

WEITER2                 MOVLW   FREQUENZ            ;BEISPIEL: 26*3SEC=78SEC SIEHE OBEN
                        CALL    ZS3MUESEC
                        DECFSZ  AD_L, F
                        GOTO    WEITER2

                        GOTO    ANFANG
                        
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;---------------------- UNTERPROGRAMME -----------------------------------------
            
;*****************************************************************************
;*                              AD-MESSUNG                                   *
;*****************************************************************************

AN_MESSEN               BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                        BSF     ADCON0, ADON
                        MOVLW   D'14'               ;14*3SEC=42SEC
                        CALL    ZS3MUESEC           ;ZEITSCHLEIFE
                        BSF     ADCON0, GO_DONE     ;GEHT LOS

III                     BTFSS  PIR1, ADIF
                        GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                        BCF     ADCON0, ADON        
                        BCF     ADCON0, GO_DONE
                        
;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;BERECHNUNG
                        BCF     STATUS, C
                        RRF     AD_H, F     ;2MAL NACH RECHTS SCHIEBEN
                        RRF     AD_L, F     ;ZU 0XFF MACHEN, AD_H ENTFLLT DANN
                        
                        BCF     STATUS, C
                        RRF     AD_H, F
                        RRF     AD_L, F
                        
;SUBTRAKTION / DURCHLUFE BERECHNEN
                        MOVF    AD_L, W     ;AD_L DARF NICHT NULL WERDEN SONDERN 0X01
                        SUBLW   0X00        
                        BTFSC   STATUS, Z
                        INCF    AD_L, F     

                        MOVF    AD_L, W     ;AD_L DARF NICHT 0XFF WERDEN SONDERN 0XFE
                        SUBLW   0XFF
                        BTFSC   STATUS, Z
                        DECF    AD_L, F
                        
                        MOVF    AD_L, W
                        SUBLW   0XFF        ;0XFF-W=W        
                        MOVWF   AD_H
                        
                        RETURN

;*****************************************************************************
;*                            ZEITSCHLEIFE  CA. X-MAL 3SEC                  *
;*****************************************************************************
ZS3MUESEC               MOVWF   HELP0
ZZS                     ;NOP         ;EIN NOP = 0.250SEC *(T=4) = 1,0SEC  
           
                        DECFSZ  HELP0, F
                        GOTO    ZZS 
                        RETURN    
;DER OSZILLATOR MIT 4,0MHZ --> (T=0.250SEC ALSO DIE TAKTZEIT)
;WEGEN DECFSZ (T=4) UND GOTO (T=8) -->GESAMT T=12 * 0,250SEC=3,0SEC
    
            END