



;*****************************************************************************
;*                            AUTOMATISCH DIMMEN                             *
;*                                                                           *
;*                            26.02.24                                       *
;*                                                                           *
;*****************************************************************************



    LIST    P=PIC12F1840
 
    ;TITLE   "DIMMER"

    ERRORLEVEL -302
    INCLUDE <P12F1840.INC>

;--------------------------------------------------------------------------

;ALS OSZILLATOR INTERN 32MHZ  (T=0.03125SEC T:=TAKTZEIT)

;---------------------------------------------------------------------------------
 
 __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _IESO_OFF & 0X3FFF
 __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _BORV_HI & _LVP_OFF & 0X3FFF
           
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
 

;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;PINS FUER DEN PIC12F1840 KURZ-SCHREIBWEISE / ZUORDNUNG
;FUER PWM
;CCP1   AN RA2 KOMMT PWM RAUS
;AN3    AN RA4 WIRD POTI ANGESCHLOSSEN AD-EINGANG 

;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 21 HEX LOS
;ALSO DIE RAM-SPEICHER ZUORDNUNG
 
;FUER ZEITSCHLEIFEN         
HELP0       EQU 0X21         
HELP1       EQU 0X22
;;;HELP2       EQU 0X23 NICHT BENUTZT
;FUER ANALOG DIGITAL WANDLUNG       
AD_L        EQU 0X24
AD_H        EQU 0X25        
;FUER ZUNEHMEND UND ABNEHMEND DER HELLIGKEIT
ZAE         EQU 0X26
;FUER BESSERE HOCH / RUNTER ZEIT --INTERVALL-ZEIT	 
HELPA       EQU 0X27   
;---------------------------------------------------------------------------------   
;---------------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN

    ORG 0X0000
    GOTO    MAIN        ;SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE              ;GOTO INTERRUPT /// JETZT KEIN INTERUPT


    ORG 0X0010                     
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;INITIALISIERUNG USW...
MAIN                    MOVLB   D'0'        ;BANK0
                        CLRF    PORTA
                        
                        MOVLB   D'2'        ;BANK2
                        CLRF    LATA                    ;ALLES DATA-LATCH
                        
                        MOVLB   D'1'        ;BANK1
                        MOVLW   B'11111011'             ;RA0_1_3_4_5 ALS EINGANG (ALSO HIER DIE 1)  // AN RA2 KOMMT PWM RAUS ALS AUSGANG
                        MOVWF   TRISA
                        
;FUER DEN INTERNEN OSZILLATOR 8MHZ /// HOLE ABER EINSTELLUNGEN AUS CONFIG INTERN "OBEN" UND PLL*4 /// DANN 32MHZ
                        MOVLW   B'11110000'             ;JETZT 8MHZ INTERN OHNE PLL*4                
                        MOVWF   OSCCON
                        
;INIT TIMER 0 FUER ZEITSCHLEIFE
                        MOVLW   B'10000111'             ;BIT0-2 000=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG 

                        MOVLB   D'2'        ;BANK2
                        CLRF    LATA                    ;ALLES DATA-LATCH
                        CLRF    APFCON                  ;RXD/TXD/CCP1-PINS VERTAUSCHEN JETZT NICHT
                        
;ALLES KEIN PULL-UP                        
                        MOVLB   D'4'        ;BANK4   
                        CLRF    WPUA      

;ANALOG/DIGITAL                        
                        MOVLB   D'3'        ;BANK3
                        MOVLW   B'00010000'             ;NUR AN3 ALLES ANDERE I/O 
                        MOVWF   ANSELA                  
                        
                        MOVLB   D'1'        ;BANK1
                        MOVLW   B'10110000'             ;RECHTSBUENDIG  FOSZ=16 INTERNER-OSZILLATOR
                        MOVWF   ADCON1
                 
;PWM
                        MOVLB   D'5'        ;BANK5
                        MOVLW   B'00001100' ;JETZT PWM MODE // MSB BIT4+5 VON CCPR1L FUER 10BITS
                        MOVWF   CCP1CON
                        
                        MOVLW   0XF0        ;BLEIBT ERHALTEN AUCH WENN CLRF CCPXCON
                        MOVWF   CCPR1L 
                        ;CLRF   CCPR1H      ;KANN ENTFALLEN
                        
                        MOVLB   D'0'        ;BANK0
                        ;BCF     PIR1, TMR2IF  ;MUSS NICHT SEIN
                        ;BCF     PIR1, CCP1IF
                        MOVLW   0XFF        ;FUER TIMER2 
                        MOVWF   PR2
                        
                        ;PROBIEREN TAKTFREQUENZ
                        MOVLW   B'00000000' ;FUER TIMER2 / PRESCALER 1 / TIMER2 OFF =0  / POSTSCALE 1:1
                        ;MOVLW   B'00000001' ;FUER TIMER2 / PRESCALER 4  / TIMER2 OFF =0  / POSTSCALE 1:1
                        ;MOVLW   B'00000010' ;FUER TIMER2 / PRESCALER 16 / TIMER2 OFF =0  / POSTSCALE 1:1
                        ;MOVLW   B'00000011' ;FUER TIMER2 / PRESCALER 64 / TIMER2 OFF =0  / POSTSCALE 1:1
                        MOVWF   T2CON
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;BERECHNUG FREQUENZ / PERIODE BEI 32MHZ INTERNER OSZILLATOR
;MIT PRESCALER 1:64
;JETZT:
;T=0.03125SEC*4*(255+1)*64
;T=0.03125SEC*1024*64=0.03125SEC*65536
;T=2,048MSEC
;F=1:2,048MSEC=488,281HZ  GEMESSEN MIT OSZI 488HZ
                        
;MIT PRESCALER 1:1  
;MAL 64*488,281HZ=31,249KHZ STIMMT MIT OSZI                             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                                               
;------------------------------ ENDE INITIALISIERUNG ---------------------------

            MOVLB   D'0'         ;BANK0

            MOVLW   D'50'       ;50MSEC ZEITSCHLEIFE   
            CALL    ZS1MSEC     ;WEGEN KONDENSATOREN AUFLADEN...
            
            BSF     T2CON, TMR2ON   ;START PWM  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BB                      CLRF    ZAE
                        
B01                     INCF    ZAE, F
                        MOVF    ZAE, W
                        SUBLW   0XFF
                        BTFSC   STATUS, Z
                        GOTO    C01
                        
                        MOVF    ZAE, W
                        MOVLB   D'5'        ;BANK5
                        MOVWF   CCPR1L
                        MOVLB   D'0'        ;BANK0
                        
                        CALL    AN3             ;CCPR1L AUS POTI-POSITION BERECHNEN
                        CALL    ZS100MUESEC
                        GOTO    B01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                      
C01                     DECF    ZAE, F
                        MOVF    ZAE, W
                        SUBLW   0X00
                        BTFSC   STATUS, Z
                        GOTO    B01
                        
                        MOVF    ZAE, W
                        MOVLB   D'5'        ;BANK5
                        MOVWF   CCPR1L
                        MOVLB   D'0'        ;BANK0
                        
                        CALL    AN3             ;CCPR1L AUS POTI-POSITION BERECHNEN
                        CALL    ZS100MUESEC
                        GOTO    C01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 X-MAL 100MUESEC            *
;*****************************************************************************                   
ZS100MUESEC             MOVWF   HELPA

ZZZ01                   MOVLW   D'231'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                 
ZZZ02                   BTFSS   INTCON, TMR0IF            
                        GOTO    ZZZ02                    
                      
                        DECFSZ  HELPA, F
                        GOTO    ZZZ01
                        
                        RETURN

;ZEITBERECHNUNG FUER 100MUESEC
;PRESCALER 32X  +  SYSTEM 4X  ====> 4*32*0,03125SEC=4SEC
;100MUESEC:4SEC=25    
;TMR0 ALSO D'256'-D'25'=D'231' ENTSPRICHT CA. 100MUESEC
;231 DEZIMAL OBEN EINTRAGEN
                           

;*****************************************************************************
;*                            ZEITSCHLEIFE  CA. X-MAL 1SEC                  *
;*****************************************************************************
ZS1MUESEC   MOVWF   HELP0
ZZS01       NOP         ;EIN NOP = 0.03125SEC *4 = 0.125SEC  (1SEC : 0.125SEC = 8 STCK. NOPS)
            NOP
            NOP
            NOP
            NOP
    
            ;NOP
            ;NOP        ;WEGGEMACHT WEGEN ZEIT VON DECFSZ UND GOTO
            ;NOP
 
            DECFSZ  HELP0, F
            GOTO    ZZS01
            RETURN    

;MIT 8XNOP(T=4) GESAMT(T=32) 32*0,03125SEC=1SEC

;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 X-MAL 1MSEC                *
;*****************************************************************************                   
ZS1MSEC                 MOVWF   HELP1

Z01                     MOVLW   D'6'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                 
Z02                     BTFSS   INTCON, TMR0IF            
                        GOTO    Z02                    
                      
                        DECFSZ  HELP1, F
                        GOTO    Z01
                        
                        RETURN

;ZEITBERECHNUNG FUER 1MSEC
;PRESCALER 32X  +  SYSTEM 4X  ====> 4*32*0,03125SEC=4SEC
;1MSEC:4SEC=250 GENOMMEN 250    
;TMR0 ALSO D'256'-D'250'=D'6' ENTSPRICHT CA. 1MSEC
;25 DEZIMAL OBEN EINTRAGEN
                            
    
;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 X-MAL 10MSEC               *
;*****************************************************************************                   
;ZS10MSEC               MOVWF   HELP2   ;NICHT BEBUTZT
                        
;ZZ01                   MOVLW   D'10'
;                       CALL    ZS1MSEC
    
;                       DECFSZ   HELP2, F
;                       GOTO     ZZ01
    
;                       RETURN
     
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;---------------------- UNTERPROGRAMME AD-MESSUNG ------------------------------
                        
;*****************************************************************************
;*                            AN1 AD-KANAL                                   *
;*****************************************************************************                           
AN3     MOVLB   D'1'    ;BANK1
        MOVLW   B'00001101'     ; AN3 [000 11], GO [0], ADON [1] 
        MOVWF   ADCON0          

        MOVLB   D'0'    ;BANK0
        MOVLW   D'40'           ;40SEC ZEITSCHLEIFE 
        CALL    ZS1MUESEC
        
;*****************************************************************************
;*                           AD-ALLGEMEIN ERGEBNIS IN W                      *
;*****************************************************************************                           
AN      MOVLB   D'1'    ;BANK1
        BSF     ADCON0, GO      ;ES STARTET

LOOP0   BTFSC   ADCON0, GO 
        GOTO    LOOP0

        ;BCF     ADCON0, ADON   ;ES STOPT
;----------------------------

        MOVF    ADRESH, W       ;ERGEBNIS VON AD-AN1 LESEN IN DEN AKKU 
        
        MOVLB   D'0'    ;BANK0
        MOVWF   AD_H            ;JETZT IN RAM-ZELLE "ADWERT" SPEICHERN

        MOVLB   D'1'    ;BANK1
        MOVF    ADRESL, W
        
        MOVLB   D'0'    ;BANK0
        MOVWF   AD_L

;----------------------------
;BERECHNUNG
                        BCF     STATUS, C   ;512
                        RRF     AD_H, F     ;2X NACH RECHTS SCHIEBEN
                        RRF     AD_L, F     ;ZU 0XFF MACHEN, AD_H ENTFLLT DANN
                        
                        BCF     STATUS, C   ;256
                        RRF     AD_H, F
                        RRF     AD_L, F

                        BCF     STATUS, C   ;128
                        RRF     AD_H, F
                        RRF     AD_L, F
                        
                        ;BCF     STATUS, C   ;64
                        ;RRF     AD_H, F
                        ;RRF     AD_L, F

                        ;BCF     STATUS, C   ;32
                        ;RRF     AD_H, F
                        ;RRF     AD_L, F

                        MOVF    AD_L, W     ;AD_L DARF NICHT NULL WERDEN SONDERN 0X01
                        SUBLW   0X00        
                        BTFSC   STATUS, Z
                        INCF    AD_L, F     
                        MOVF    AD_L, W
        RETURN    
      
    
        
        END





